#include "alphanum_compare.hh"

#include <string>
#include <iostream>


int main(int argc, char* argv[])
{
  if (argc != 3) {
    std::cerr << "usage: alphanum word1 word2\n";
    return 1;
  }

  std::string a(argv[1]);
  std::string b(argv[2]);

  bool a_less = pbe::alphanum_compare(a.begin(),a.end(),b.begin(),b.end());
  bool b_less = pbe::alphanum_compare(b,a);

  if (a_less) std::cerr << a << " < " << b << "\n";
  if (b_less) std::cerr << b << " < " << a << "\n";
  if (!a_less && !b_less) std::cerr << a << " == " << b << "\n";

  return 0;
}

