// include/NonMutex.hh
// This file is part of libpbe; see http://svn.chezphil.org/libpbe/
// (C) 2013 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef libpbe_NonMutex_hh
#define libpbe_NonMutex_hh


// This file provides class NonMutex, which is a model of a non-recursive 
// timed Mutex as defined in N2447.
// Except that it isn't.  It doesn't actually implement any mutual exclusion.


#include <boost/noncopyable.hpp>


namespace pbe {

class NonMutex: boost::noncopyable {
public:
  void lock() {}
  bool try_lock() { return true; }
  typedef uint32_t microseconds_t;
  bool timed_lock(microseconds_t rel_time) { return true; }
  bool timed_lock(float rel_time) { return true; }
  void unlock() {}

};

};


#endif

