// include/Spinlock.hh
// This file is part of libpbe; see http://svn.chezphil.org/libpbe/
// (C) 2013 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef libpbe_Spinlock_hh
#define libpbe_Spinlock_hh

// The file implements a Spinlock using Boost.Atomic.

#include <boost/atomic.hpp>


namespace pbe {


class Spinlock {

  boost::atomic<bool> locked;

public:

  Spinlock(): locked(false) {}

  void lock() {
    while (locked.exchange(true, boost::memory_order_acquire) == true) { /*spin*/ }
  }

  void unlock() {
    locked.store(false, boost::memory_order_release);
  }

};


};


#endif





