// include/predicates.hh
// This file is part of libpbe; see http://svn.chezphil.org/libpbe/
// (C) 2009-2017 Philip Endecott

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef libpbe_predicates_hh
#define libpbe_predicates_hh


namespace pbe {

// This is made more difficult than it need be due to lack of 
// specialisation of function templates.  Is there a better way?
// Fold expressions?

namespace detail {

  template <char... cs>
  struct is_any_of_s {
  };

  template <>
  struct is_any_of_s<> {
    bool operator()(char) { return false; }
  };

  template <char c1, char... cs>
  struct is_any_of_s<c1,cs...> {
    bool operator()(char c) { return c==c1 || is_any_of_s<cs...>()(c); }
  };

};


template <char... cs>
bool is_any_of(char c) {
  return detail::is_any_of_s<cs...>()(c);
}


};


#endif




